<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
  {% if params.baseHref %}
    <base href="{{ params.baseHref }}">
  {% endif %}
    <title>{{ asyncapi.info().title() }} {{ asyncapi.info().version() }} documentation</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.61.1/codemirror.min.css"></link>
    <link rel="stylesheet" href="theme/infobip.css?date=2021-06-10">

    <link href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet">
  {% if params.singleFile %}
    <style type="text/css">
      {{ "template/css/styles.min.css" | includeFile | safe }}
    </style>
  {% else %}
    <link href="css/styles.min.css?date=2021-06-10" rel="stylesheet">
  {% endif %}
  <link href="https://fonts.googleapis.com/css?family=Montserrat:300,400,700|Roboto:300,400,700" rel="stylesheet">
  <link href="https://fonts.googleapis.com/css?family=Roboto" rel="stylesheet" type="text/css">
  </head>

  <body>

    <div class="flex flex-col h-screen">
      <header class="py-4 bg-gray-50 text-black text-center shadow-2xl">
        <div class="flex flex-row">
          <div class="flex-initial mx-2.5 sm:mx-8 md:mx-8">
            <a class="" target="_blank" href="https://infobip.com">
              <img class="c-img" src="https://www.infobip.com/docs/assets/img/docs-new/icons/ic-logo.svg" alt="Infobip logo">
            </a>
          </div>
          <div class="flex-1 text-center md:mx-14">
            <ul class="flex flex-row">
              <li class="flex-initial mx-8">
                <a class="text-4xl header-link-text underline" onclick="show_docs()" id="docs_link">API</a>
              </li>
              <li class="flex-initial mx-8">
                <a class="text-4xl header-link-text header-link-text-not-selected" onclick="show_specs()" id="specs_link">Specs</a>
              </li>
            </ul>
          </div>
        </div>
      </header>

      <main class="flex-1 overflow-y-auto" id="main">
        <div id="docs">
          <div id="root">{{ asyncapi | renderSpec(params) | safe }}</div>
        </div>
        <div id="specs">
          <div id="editor"></div>
        </div>
      </main>

      <footer class="py-4 bg-gray-50 text-right text-black">
        <div class="mx-8">
          Copyright © from 2019 onwards <a target="_blank" href="https://airt.ai">airt.ai</a>
        </div>
      </footer>
    </div>
  {% if params.singleFile %}
    <script type="text/javascript">
      {{ "template/js/react.production.min.js" | includeFile | safe }}
    </script>
    <script type="text/javascript">
      {{ "template/js/react-dom.production.min.js" | includeFile | safe }}
    </script>
    <script type="text/javascript">
      {{ "template/js/asyncapi-ui.min.js" | includeFile | safe }}
    </script>
  {% else %}
    <script src="js/react.production.min.js" type="application/javascript"></script>
    <script src="js/react-dom.production.min.js" type="application/javascript"></script>
    <script src="js/asyncapi-ui.min.js" type="application/javascript"></script>
  {% endif %}

    <script>
      var schema = {{ asyncapi | stringifySpec | safe }};
      var config = {{ params | stringifyConfiguration | safe }};
      ReactDOM.hydrate(
        React.createElement(AsyncApiComponent, { schema, config }),
        document.getElementById("root")
      );
    </script>

    <script>
      // Based on https://stackoverflow.com/a/44768166/3664629
      docs_div = document.getElementById("docs")
      specs_div = document.getElementById("specs")

      docs_link = document.getElementById("docs_link")
      specs_link = document.getElementById("specs_link")

      function show_docs() {
        docs_div.style.display = "block";
        specs_div.style.display = "none";

        docs_link.classList.add("underline");
        docs_link.classList.remove("header-link-text-not-selected");
        specs_link.classList.add("header-link-text-not-selected");
        specs_link.classList.remove("underline");

        docs_div.scrollIntoView();
        specs_div.scrollIntoView();
      }

      function show_specs() {
        specs_div.style.display = "block";
        docs_div.style.display = "none";

        specs_link.classList.add("underline");
        specs_link.classList.remove("header-link-text-not-selected");
        docs_link.classList.add("header-link-text-not-selected");
        docs_link.classList.remove("underline");

        docs_div.scrollIntoView();
        specs_div.scrollIntoView();
      }

    </script>

    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.61.1/codemirror.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.61.1/mode/yaml/yaml.min.js"></script>

    <script>
      fetch("/asyncapi.yml")
      .then(response => response.text())
      .then(data =>

        CodeMirror(document.querySelector('#editor'), {
          lineNumbers: true,
          tabSize: 2,
          value: data,
          mode: "text/x-yaml",
          theme: "infobip",
          readOnly: true,
          scrollbarStyle: "native"
        }) &&

        show_docs()

      );
    </script>
  </body>
</html>
